/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO
 *
 */

package de.ivu.elect.business.ergebnis.boundary;

import javax.persistence.NoResultException;
import javax.persistence.NonUniqueResultException;
import javax.persistence.EntityNotFoundException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import de.ivu.elect.business.ergebnis.entity.Stimmen;
import de.ivu.elect.business.ergebnis.entity.StimmenUK;

public abstract class AbstractStimmenDAO extends de.ivu.elect.jee.entity.AbstractDAO<Stimmen,
        de.ivu.elect.business.ergebnis.entity.StimmenPK
    , StimmenUK> {

  private static final long serialVersionUID = 1L;

  private static final Logger LOG = LoggerFactory.getLogger(AbstractStimmenDAO.class);

  public AbstractStimmenDAO() {
    super();
  }

  public boolean isEntityWithPKPresent(
            de.ivu.elect.business.ergebnis.entity.StimmenPK
     pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk) != null;
    }

    return false;
  }

  @Override
  public Stimmen findByPrimaryKey(
        de.ivu.elect.business.ergebnis.entity.StimmenPK
      pk) {
    if (pk != null && pk.getId() != null) {
      return findByPrimaryKey(pk.getId());
    }

    throw new IllegalArgumentException("PK oder PK.getId() ist null! [pk = " + pk + "]");
  }


  @Override
  protected Stimmen findByPrimaryKey(Long id) {
    if (id == null) {
      throw new IllegalArgumentException("ID ist null! [id = " + id + "]");
    }
  return getEntityManager().find(Stimmen.class, id, CACHE_PROPERTIES);
  }



     /**
      * Name: ByErgebnisAndGebietNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: DELETE FROM Stimmen s WHERE s.ergebnis = ?1 AND s.gebiet IN (?2)<br>
      * SQL: <br>
      */
     public Integer deleteByErgebnisAndGebiet( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("STIMMEN.ByErgebnisAndGebiet")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebieteCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, deleteByErgebnisAndGebiet - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiete:'"+gebiete+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByErgebnisAndGebiet(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ByErgebnisNoFlush<br>
      * Beschreibung: Löscht alle Stimmen zu einem Ergebnis, e.q. für den Import von Stimmen.<br>
      * EJBQL: DELETE FROM Stimmen s WHERE s.ergebnis = ?1<br>
      * SQL: <br>
      */
     public Integer deleteByErgebnis( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                    (Integer)
                              getEntityManager().
                                createNamedQuery("STIMMEN.ByErgebnis")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                                .executeUpdate();
          
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, deleteByErgebnis - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".deleteByErgebnis(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountByErgebnisAndGruppeNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT COUNT(o) FROM Stimmen o WHERE o.ergebnis=?1 AND o.gruppe=?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountByErgebnisAndGruppe( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("STIMMEN.CountByErgebnisAndGruppe")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gruppeCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountByErgebnisAndGruppe - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByCountByErgebnisAndGruppe - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountByErgebnisAndGruppe(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: CountStimmenByWahlAndErgebnisartNoFlush<br>
      * Beschreibung: Dient der Bestimmung, ob für eine Ergebnisart bereits Stimmen vorliegen.<br>
      * EJBQL: SELECT count(s) FROM Stimmen s WHERE s.ergebnis.wahl = ?1 AND s.ergebnis.ergebnisart=?2<br>
      * SQL: <br>
      */
     public java.lang.Long findByCountStimmenByWahlAndErgebnisart( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.wahl.entity.Wahl wahlCheckedAndAttached =  checkAndAttach(wahl, de.ivu.elect.business.wahl.entity.Wahl.class, "wahl"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisartCheckedAndAttached =  checkAndAttach(ergebnisart, de.ivu.elect.business.ergebnis.entity.Ergebnisart.class, "ergebnisart"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("STIMMEN.CountStimmenByWahlAndErgebnisart")
                              .setParameter(1, wahlCheckedAndAttached)
                                        .setParameter(2, ergebnisartCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByCountStimmenByWahlAndErgebnisart - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByCountStimmenByWahlAndErgebnisart - NonUniqueResultException, Parameter: "
           + ", wahl:'"+wahl+"'"
           + ", ergebnisart:'"+ergebnisart+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByCountStimmenByWahlAndErgebnisart(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndGebietAndGruppeNoCacheNoFlush<br>
      * Beschreibung: Findet alle Stimmen zu einem Ergebnis auf einem Gebiet, e.q. zur Bearbeitung der Stimmen auf einem Gebiet einer Partei. Siehe freihändige Manipulation für die Erstellung von Testmaterial.<br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.gebiet=?2 AND o.gruppe=?3<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisAndGebietAndGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisAndGebietAndGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                        .setParameter(3, gruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisAndGebietAndGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiet:'"+gebiet+"'"
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndGebietAndGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndGebietNoCacheNoFlush<br>
      * Beschreibung: Findet alle Stimmen zu einem Ergebnis auf einem Gebiet, e.q. zur gruppierten Anzeige der Stimmen und zur Bearbeitung der Stimmen pro Gebiet.<br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.gebiet=?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisAndGebietNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisAndGebietNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisAndGebietNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndGebietNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndGebieteNoCacheNoFlush<br>
      * Beschreibung: Wird für die Kummlierung von Stimmen auf einem Gebiet benutzt.<br>
      * EJBQL: SELECT s FROM Stimmen s WHERE s.ergebnis=?1 AND s.gebiet IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisAndGebieteNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisAndGebieteNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebieteCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisAndGebieteNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiete:'"+gebiete+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndGebieteNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndGruppeNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.gruppe=?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisAndGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.Gruppe gruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gruppe.entity.Gruppe gruppeCheckedAndAttached =  checkAndAttach(gruppe, de.ivu.elect.business.gruppe.entity.Gruppe.class, "gruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisAndGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisAndGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gruppe:'"+gruppe+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndIsSystemGruppeNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT s FROM Stimmen s WHERE s.ergebnis=?1 AND s.gruppe.gruppeArt = de.ivu.elect.business.gruppe.entity.GruppeArt.SYSTEM_GRUPPE<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisAndIsSystemGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisAndIsSystemGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisAndIsSystemGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndIsSystemGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisAndIsSystemGruppeReadOnlyNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen(s.id, s.ergebnis.id, s.gebiet.id, s.gruppe.id, s.referendumOption.id, s.anzahl, s.stimmenart) FROM Stimmen s WHERE s.ergebnis=?1 AND s.gruppe.gruppeArt = de.ivu.elect.business.gruppe.entity.GruppeArt.SYSTEM_GRUPPE<br>
      * SQL: <br>
      */
     public java.util.List<de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen> findByErgebnisAndIsSystemGruppeReadOnlyNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisAndIsSystemGruppeReadOnlyNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisAndIsSystemGruppeReadOnlyNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisAndIsSystemGruppeReadOnlyNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisCountAnzahlStimmenNoFlush<br>
      * Beschreibung: Zählt die Anzahl der Stimmen für ein Ergebnis. Wird als Pre-Condition-Check verwendet, um zu überprüfen, ob für ein Ergebnis bereits Stimmen vorliegen.<br>
      * EJBQL: SELECT COUNT(s) FROM Stimmen s WHERE s.ergebnis = ?1<br>
      * SQL: <br>
      */
     public java.lang.Long findByErgebnisCountAnzahlStimmen( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                    (java.lang.Long)
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisCountAnzahlStimmen")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getSingleResult();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByErgebnisCountAnzahlStimmen - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisCountAnzahlStimmen - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisCountAnzahlStimmen(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisDirektstimmenFuerPolitischeGruppeNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = de.ivu.elect.business.ergebnis.entity.Stimmenart.DIREKTSTIMME AND o.gruppe =?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisDirektstimmenFuerPolitischeGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppeCheckedAndAttached =  checkAndAttach(politischeGruppe, de.ivu.elect.business.gruppe.entity.PolitischeGruppe.class, "politischeGruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisDirektstimmenFuerPolitischeGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, politischeGruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisDirektstimmenFuerPolitischeGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", politischeGruppe:'"+politischeGruppe+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisDirektstimmenFuerPolitischeGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisDirektstimmenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = de.ivu.elect.business.ergebnis.entity.Stimmenart.DIREKTSTIMME<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisDirektstimmenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisDirektstimmenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisDirektstimmenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisDirektstimmenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisListenkandidaturstimmenFuerPolitischeGruppeNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NOT NULL AND o.gruppe =?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisListenkandidaturstimmenFuerPolitischeGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppeCheckedAndAttached =  checkAndAttach(politischeGruppe, de.ivu.elect.business.gruppe.entity.PolitischeGruppe.class, "politischeGruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisListenkandidaturstimmenFuerPolitischeGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, politischeGruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisListenkandidaturstimmenFuerPolitischeGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", politischeGruppe:'"+politischeGruppe+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisListenkandidaturstimmenFuerPolitischeGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisListenkandidaturstimmenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NOT NULL<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisListenkandidaturstimmenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisListenkandidaturstimmenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisListenkandidaturstimmenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisListenkandidaturstimmenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisListenkandidaturstimmenReadOnlyNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen(s.id, s.ergebnis.id, s.gebiet.id, s.gruppe.id, s.referendumOption.id, s.anzahl, s.stimmenart, s.listenkandidatur.id) FROM Stimmen s WHERE s.ergebnis=?1 AND s.listenkandidatur IS NOT NULL<br>
      * SQL: <br>
      */
     public java.util.List<de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen> findByErgebnisListenkandidaturstimmenReadOnly( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisListenkandidaturstimmenReadOnly")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisListenkandidaturstimmenReadOnly - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisListenkandidaturstimmenReadOnly(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisListenstimmenOhneListenkandidaturenFuerPolitischeGruppeNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = de.ivu.elect.business.ergebnis.entity.Stimmenart.LISTENSTIMME AND o.gruppe =?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisListenstimmenOhneListenkandidaturenFuerPolitischeGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppeCheckedAndAttached =  checkAndAttach(politischeGruppe, de.ivu.elect.business.gruppe.entity.PolitischeGruppe.class, "politischeGruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisListenstimmenOhneListenkandidaturenFuerPolitischeGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, politischeGruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisListenstimmenOhneListenkandidaturenFuerPolitischeGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", politischeGruppe:'"+politischeGruppe+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisListenstimmenOhneListenkandidaturenFuerPolitischeGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisListenstimmenOhneListenkandidaturenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = de.ivu.elect.business.ergebnis.entity.Stimmenart.LISTENSTIMME<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisListenstimmenOhneListenkandidaturenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisListenstimmenOhneListenkandidaturenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisListenstimmenOhneListenkandidaturenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisListenstimmenOhneListenkandidaturenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisNoCacheNoFlush<br>
      * Beschreibung: Findet alle Stimmen zu einem Ergebnis, siehe de.ivu.elect.business.ergebnis.boundary.StimmenSearch.<br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisOhneListenkandidaturenFuerGruppenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.gruppe IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisOhneListenkandidaturenFuerGruppenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gruppe.entity.Gruppe> gruppen) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gruppe.entity.Gruppe> gruppenCheckedAndAttached =  gruppen ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisOhneListenkandidaturenFuerGruppenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gruppenCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisOhneListenkandidaturenFuerGruppenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gruppen:'"+gruppen+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisOhneListenkandidaturenFuerGruppenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisOhneListenkandidaturenFuerGruppenUndGebieteNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.gruppe IN (?2) AND o.gebiet IN (?3)<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisOhneListenkandidaturenFuerGruppenUndGebieteNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gruppe.entity.Gruppe> gruppen,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gruppe.entity.Gruppe> gruppenCheckedAndAttached =  gruppen ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisOhneListenkandidaturenFuerGruppenUndGebieteNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gruppenCheckedAndAttached)
                                        .setParameter(3, gebieteCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisOhneListenkandidaturenFuerGruppenUndGebieteNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gruppen:'"+gruppen+"'"
           + ", gebiete:'"+gebiete+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisOhneListenkandidaturenFuerGruppenUndGebieteNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisOhneListenkandidaturenReadOnlyNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen(s.id, s.ergebnis.id, s.gebiet.id, s.gruppe.id, s.referendumOption.id, s.anzahl, s.stimmenart) FROM Stimmen s WHERE s.ergebnis=?1 AND s.listenkandidatur IS NULL<br>
      * SQL: <br>
      */
     public java.util.List<de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen> findByErgebnisOhneListenkandidaturenReadOnlyNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisOhneListenkandidaturenReadOnlyNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisOhneListenkandidaturenReadOnlyNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisOhneListenkandidaturenReadOnlyNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisOhneListenkandidaturenUndGebietenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.gebiet IN (?2)<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisOhneListenkandidaturenUndGebietenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisOhneListenkandidaturenUndGebietenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebieteCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisOhneListenkandidaturenUndGebietenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiete:'"+gebiete+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisOhneListenkandidaturenUndGebietenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisReadOnlyNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen(s.id, s.ergebnis.id, s.gebiet.id, s.gruppe.id, s.referendumOption.id, s.anzahl, s.stimmenart, s.listenkandidatur.id) FROM Stimmen s WHERE s.ergebnis=?1<br>
      * SQL: <br>
      */
     public java.util.List<de.ivu.elect.business.ergebnis.entity.ReadOnlyGruppenStimmen> findByErgebnisReadOnlyNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisReadOnlyNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisReadOnlyNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisReadOnlyNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisReferendumstimmenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = de.ivu.elect.business.ergebnis.entity.Stimmenart.REFERENDUM_STIMME<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisReferendumstimmenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisReferendumstimmenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisReferendumstimmenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisReferendumstimmenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisStimmenartOhneListenkandidaturenFuerPolitischeGruppeNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = ?2 AND o.gruppe =?3<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisStimmenartOhneListenkandidaturenFuerPolitischeGruppeNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenart,  @javax.annotation.Nonnull de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppe) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenartCheckedAndAttached =  checkAndAttach(stimmenart, de.ivu.elect.business.ergebnis.entity.Stimmenart.class, "stimmenart"); ;
		  			  de.ivu.elect.business.gruppe.entity.PolitischeGruppe politischeGruppeCheckedAndAttached =  checkAndAttach(politischeGruppe, de.ivu.elect.business.gruppe.entity.PolitischeGruppe.class, "politischeGruppe"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisStimmenartOhneListenkandidaturenFuerPolitischeGruppeNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, stimmenartCheckedAndAttached)
                                        .setParameter(3, politischeGruppeCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisStimmenartOhneListenkandidaturenFuerPolitischeGruppeNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", stimmenart:'"+stimmenart+"'"
           + ", politischeGruppe:'"+politischeGruppe+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisStimmenartOhneListenkandidaturenFuerPolitischeGruppeNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisStimmenartOhneListenkandidaturenNoCacheNoFlush<br>
      * Beschreibung: <br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis=?1 AND o.listenkandidatur IS NULL AND o.stimmenart = ?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisStimmenartOhneListenkandidaturenNoCache( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenart) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  de.ivu.elect.business.ergebnis.entity.Stimmenart stimmenartCheckedAndAttached =  checkAndAttach(stimmenart, de.ivu.elect.business.ergebnis.entity.Stimmenart.class, "stimmenart"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisStimmenartOhneListenkandidaturenNoCache")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, stimmenartCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisStimmenartOhneListenkandidaturenNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", stimmenart:'"+stimmenart+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisStimmenartOhneListenkandidaturenNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: ErgebnisseAndGebietNoCacheNoFlush<br>
      * Beschreibung: Siehe de.ivu.elect.business.ergebnis.boundary.StimmenSearch.<br>
      * EJBQL: SELECT o FROM Stimmen o WHERE o.ergebnis IN (?1) AND o.gebiet=?2<br>
      * SQL: <br>
      */
     public java.util.List<Stimmen> findByErgebnisseAndGebietNoCache( @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.ergebnis.entity.Ergebnis> ergebnisse,  @javax.annotation.Nonnull de.ivu.elect.business.gebietsbaum.entity.Gebiet gebiet) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

            try {

          		  			  java.util.Collection<de.ivu.elect.business.ergebnis.entity.Ergebnis> ergebnisseCheckedAndAttached =  ergebnisse ;
		  			  de.ivu.elect.business.gebietsbaum.entity.Gebiet gebietCheckedAndAttached =  checkAndAttach(gebiet, de.ivu.elect.business.gebietsbaum.entity.Gebiet.class, "gebiet"); ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.ErgebnisseAndGebietNoCache")
                              .setParameter(1, ergebnisseCheckedAndAttached)
                                        .setParameter(2, gebietCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByErgebnisseAndGebietNoCache - NonUniqueResultException, Parameter: "
           + ", ergebnisse:'"+ergebnisse+"'"
           + ", gebiet:'"+gebiet+"'"
    
        );
    throw nure;
        }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByErgebnisseAndGebietNoCache(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }

     /**
      * Name: StimmenAnzahlByStimmartUndGruppeAndCountNoFlush<br>
      * Beschreibung: Findet die Anzahl der Stimmen pro Gruppe in den angegebenen Gebieten (für die Stimmen zu einem Ergebnis). Wir für die grafische Darstellung von Stimmen benötigt.<br>
      * EJBQL: SELECT new de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe(s.gruppe, s.stimmenart, SUM(s.anzahl)) FROM Stimmen s WHERE s.ergebnis=?1 AND s.gebiet IN (?2) GROUP BY s.gruppe, s.stimmenart<br>
      * SQL: <br>
      */
     public java.util.List<de.ivu.elect.business.ergebnis.entity.StimmenAnzahlByStimmartUndGruppe> findByStimmenAnzahlByStimmartUndGruppeAndCount( @javax.annotation.Nonnull de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnis,  @javax.annotation.Nonnull java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebiete) {
            long start = 0L;

            if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
               start = System.currentTimeMillis();
            }

    try {

        int versuch = 0;
      while (true) {
        versuch++;
                try {

          		  			  de.ivu.elect.business.ergebnis.entity.Ergebnis ergebnisCheckedAndAttached =  checkAndAttach(ergebnis, de.ivu.elect.business.ergebnis.entity.Ergebnis.class, "ergebnis"); ;
		  			  java.util.Collection<de.ivu.elect.business.gebietsbaum.entity.Gebiet> gebieteCheckedAndAttached =  gebiete ;
		  
                              return
                              getEntityManager().
                                createNamedQuery("STIMMEN.StimmenAnzahlByStimmartUndGruppeAndCount")
                              .setParameter(1, ergebnisCheckedAndAttached)
                                        .setParameter(2, gebieteCheckedAndAttached)
                                                                      .getResultList();
                                        
                    
        } catch (EntityNotFoundException enfe) {
      // ELECTMUC-2455
       if (de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.INVALIDATE_CACHE &&
       versuch < de.ivu.elect.business.system.control.InvalidateCacheOnEntityNotFound.MAX_VERSUCHE ) {
       LOG.warn("findByStimmenAnzahlByStimmartUndGruppeAndCount - EntityNotFoundException: " +enfe.getMessage()+", Versuch: " +versuch+" - lösche Cache - wiederhole");
        try {
         de.ivu.elect.business.system.boundary.CacheResetSession.reset(getEntityManager());
        } catch (Exception e) {
          LOG.warn("Fehler beim Zurücksetzen des Cache: "+e.getMessage());

        }
       } else {
        throw enfe;
       }
           } catch (NonUniqueResultException nure) {
    LOG.warn("Stimmen, findByStimmenAnzahlByStimmartUndGruppeAndCount - NonUniqueResultException, Parameter: "
           + ", ergebnis:'"+ergebnis+"'"
           + ", gebiete:'"+gebiete+"'"
    
        );
    throw nure;
            }
            }

    } finally {
    if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
    LOG.info("Query: " + getClass().getName()+".findByStimmenAnzahlByStimmartUndGruppeAndCount(): "+(System.currentTimeMillis()-start)+ " ms");
    }
    }
     }



  @Override
  public boolean isEntityWithUKPresent(de.ivu.elect.business.ergebnis.entity.StimmenUK uk) {
    try {
      return findByUK(uk) != null;
    } catch (javax.persistence.NoResultException nre) {
      return false;
    }
  }

  @Override
  public boolean isEntityWithUKHasPK(de.ivu.elect.business.ergebnis.entity.StimmenUK uk,
        de.ivu.elect.business.ergebnis.entity.StimmenPK
      pk

  ) {
    try {
      return findByUK(uk).getPk().equals(pk);
    } catch (NoResultException ignored) {
      // Do nothing - be happy.
    }
    return true;
  }

   public de.ivu.elect.business.ergebnis.entity.Stimmen findByUK(de.ivu.elect.business.ergebnis.entity.StimmenUK uk){

    try {
     return (de.ivu.elect.business.ergebnis.entity.Stimmen) getEntityManager().createNamedQuery("STIMMEN.UK")
                  .setParameter(1, uk
                .getStimmenart ()  
              )
             .setParameter(2, uk
                .getErgebnisUK ()  
                .getErgebnisart ()  
              )
             .setParameter(3, uk
                .getErgebnisUK ()  
                .getName ()  
              )
             .setParameter(4, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(5, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(6, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(7, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(8, uk
                .getErgebnisUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(9, uk
                .getGebietUK ()  
                .getNummer ()  
              )
             .setParameter(10, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getName ()  
              )
             .setParameter(11, uk
                .getGebietUK ()  
                .getGebietsartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(12, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(13, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(14, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(15, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(16, uk
                .getGebietUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(17, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(18, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(19, uk
                .getGebietUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(20, uk
                .getGruppeUK ()  
                .getSchluessel ()  
              )
             .setParameter(21, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getName ()  
              )
             .setParameter(22, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlartUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
             .setParameter(23, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getNummer ()  
              )
             .setParameter(24, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getWahldatum ()  , javax.persistence.TemporalType.DATE /*ELECT-13069*/ 
              )
             .setParameter(25, uk
                .getGruppeUK ()  
                .getWahlUK ()  
                .getWahlterminUK ()  
                .getMandantUK ()  
                .getNummer ()  
              )
          .getSingleResult()
     ;
     } catch (NonUniqueResultException nure) {
        LOG.warn("Stimmen, findByUK - NonUniqueResultException, UK: " + uk);
        throw nure;
     }
  }
    
}